Index: src/backend/commands/view.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/view.c,v
retrieving revision 1.63
diff -c -r1.63 view.c
*** src/backend/commands/view.c	2002/04/19 23:13:54	1.63
--- src/backend/commands/view.c	2002/06/15 16:38:22
***************
*** 255,261 ****
   *------------------------------------------------------------------
   */
  void
! RemoveView(const RangeVar *view)
  {
  	Oid			viewOid;
  
--- 255,261 ----
   *------------------------------------------------------------------
   */
  void
! RemoveView(const RangeVar *view, int behavior)
  {
  	Oid			viewOid;
  
***************
*** 264,268 ****
  	 * We just have to drop the relation; the associated rules will be
  	 * cleaned up automatically.
  	 */
! 	heap_drop_with_catalog(viewOid, allowSystemTableMods);
  }
--- 264,268 ----
  	 * We just have to drop the relation; the associated rules will be
  	 * cleaned up automatically.
  	 */
! 	heap_drop_with_catalog(viewOid, allowSystemTableMods, behavior);
  }
Index: src/backend/nodes/copyfuncs.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/nodes/copyfuncs.c,v
retrieving revision 1.188
diff -c -r1.188 copyfuncs.c
*** src/backend/nodes/copyfuncs.c	2002/05/22 17:20:58	1.188
--- src/backend/nodes/copyfuncs.c	2002/06/15 16:38:26
***************
*** 1505,1512 ****
  	Node_Copy(from, newnode, pktable);
  	Node_Copy(from, newnode, fk_attrs);
  	Node_Copy(from, newnode, pk_attrs);
! 	if (from->match_type)
! 		newnode->match_type = pstrdup(from->match_type);
  	newnode->actions = from->actions;
  	newnode->deferrable = from->deferrable;
  	newnode->initdeferred = from->initdeferred;
--- 1505,1511 ----
  	Node_Copy(from, newnode, pktable);
  	Node_Copy(from, newnode, fk_attrs);
  	Node_Copy(from, newnode, pk_attrs);
! 	newnode->match_type = from->match_type;
  	newnode->actions = from->actions;
  	newnode->deferrable = from->deferrable;
  	newnode->initdeferred = from->initdeferred;
***************
*** 1642,1647 ****
--- 1641,1647 ----
  	newnode->setof = from->setof;
  	newnode->pct_type = from->pct_type;
  	newnode->typmod = from->typmod;
+ 	newnode->serial = from->serial;
  	Node_Copy(from, newnode, arrayBounds);
  
  	return newnode;
Index: src/backend/nodes/equalfuncs.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/nodes/equalfuncs.c,v
retrieving revision 1.135
diff -c -r1.135 equalfuncs.c
*** src/backend/nodes/equalfuncs.c	2002/05/22 17:20:59	1.135
--- src/backend/nodes/equalfuncs.c	2002/06/15 16:38:29
***************
*** 1602,1607 ****
--- 1602,1609 ----
  		return false;
  	if (!equal(a->arrayBounds, b->arrayBounds))
  		return false;
+ 	if (a->serial != b->serial)
+ 		return false;
  
  	return true;
  }
***************
*** 1736,1742 ****
  		return false;
  	if (!equal(a->pk_attrs, b->pk_attrs))
  		return false;
! 	if (!equalstr(a->match_type, b->match_type))
  		return false;
  	if (a->actions != b->actions)
  		return false;
--- 1738,1744 ----
  		return false;
  	if (!equal(a->pk_attrs, b->pk_attrs))
  		return false;
! 	if (a->match_type != b->match_type)
  		return false;
  	if (a->actions != b->actions)
  		return false;
Index: src/backend/nodes/outfuncs.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/nodes/outfuncs.c,v
retrieving revision 1.159
diff -c -r1.159 outfuncs.c
*** src/backend/nodes/outfuncs.c	2002/05/12 23:43:02	1.159
--- src/backend/nodes/outfuncs.c	2002/06/15 16:38:32
***************
*** 1444,1451 ****
  	_outNode(str, node->fk_attrs);
  	appendStringInfo(str, " :pk_attrs ");
  	_outNode(str, node->pk_attrs);
! 	appendStringInfo(str, " :match_type ");
! 	_outToken(str, node->match_type);
  	appendStringInfo(str, " :actions %d :deferrable %s :initdeferred %s",
  					 node->actions,
  					 booltostr(node->deferrable),
--- 1444,1451 ----
  	_outNode(str, node->fk_attrs);
  	appendStringInfo(str, " :pk_attrs ");
  	_outNode(str, node->pk_attrs);
! 	appendStringInfo(str, " :match_type %c",
! 					 node->match_type);
  	appendStringInfo(str, " :actions %d :deferrable %s :initdeferred %s",
  					 node->actions,
  					 booltostr(node->deferrable),
Index: src/backend/parser/analyze.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/parser/analyze.c,v
retrieving revision 1.236
diff -c -r1.236 analyze.c
*** src/backend/parser/analyze.c	2002/06/13 02:04:46	1.236
--- src/backend/parser/analyze.c	2002/06/15 16:38:41
***************
*** 773,781 ****
  	q->commandType = CMD_UTILITY;
  	q->utilityStmt = (Node *) stmt;
  	stmt->tableElts = cxt.columns;
! 	stmt->constraints = cxt.ckconstraints;
! 	*extras_before = nconc (*extras_before, cxt.blist);
! 	*extras_after = nconc (cxt.alist, *extras_after);
  
  	return q;
  }
--- 773,781 ----
  	q->commandType = CMD_UTILITY;
  	q->utilityStmt = (Node *) stmt;
  	stmt->tableElts = cxt.columns;
! 	stmt->constraints = nconc(cxt.ckconstraints, cxt.fkconstraints);
! 	*extras_before = nconc(*extras_before, cxt.blist);
! 	*extras_after = nconc(cxt.alist, *extras_after);
  
  	return q;
  }
***************
*** 826,837 ****
--- 826,839 ----
  		A_Const    *snamenode;
  		FuncCall   *funccallnode;
  		CreateSeqStmt *seqstmt;
+ 		RangeVar   *srvar;
  
  		/*
  		 * Determine name and namespace to use for the sequence.
  		 */
  		sname = makeObjectName(cxt->relation->relname, column->colname, "seq");
  		snamespace = get_namespace_name(RangeVarGetCreationNamespace(cxt->relation));
+ 		srvar=makeRangeVar(snamespace, sname);
  
  		elog(NOTICE, "%s will create implicit sequence '%s' for SERIAL column '%s.%s'",
  			 cxt->stmtType, sname, cxt->relation->relname, column->colname);
***************
*** 842,853 ****
  		 * CREATE/ALTER TABLE.
  		 */
  		seqstmt = makeNode(CreateSeqStmt);
! 		seqstmt->sequence = makeRangeVar(snamespace, sname);
  		seqstmt->options = NIL;
  
  		cxt->blist = lappend(cxt->blist, seqstmt);
  
  		/*
  		 * Create appropriate constraints for SERIAL.  We do this in full,
  		 * rather than shortcutting, so that we will detect any
  		 * conflicting constraints the user wrote (like a different
--- 844,861 ----
  		 * CREATE/ALTER TABLE.
  		 */
  		seqstmt = makeNode(CreateSeqStmt);
! 		seqstmt->sequence = srvar;
  		seqstmt->options = NIL;
  
  		cxt->blist = lappend(cxt->blist, seqstmt);
  
  		/*
+ 		 * Keep the serial name so that lateron the table can create an
+ 		 * implicit dependency to drop the serial with the table
+ 		 */
+ 		column->typename->serial = srvar;
+ 
+ 		/*
  		 * Create appropriate constraints for SERIAL.  We do this in full,
  		 * rather than shortcutting, so that we will detect any
  		 * conflicting constraints the user wrote (like a different
***************
*** 1304,1315 ****
  static void
  transformFKConstraints(ParseState *pstate, CreateStmtContext *cxt)
  {
- 	CreateTrigStmt *fk_trigger;
  	List	   *fkactions = NIL;
  	List	   *fkclist;
- 	List	   *fk_attr;
- 	List	   *pk_attr;
- 	Ident	   *id;
  	Oid			pktypoid[INDEX_MAX_KEYS];
  	Oid			fktypoid[INDEX_MAX_KEYS];
  	int			i;
--- 1312,1319 ----
***************
*** 1325,1336 ****
  		FkConstraint *fkconstraint = (FkConstraint *) lfirst(fkclist);
  		int			attnum;
  		List	   *fkattrs;
  
  		/*
  		 * If the constraint has no name, set it to <unnamed>
  		 */
  		if (fkconstraint->constr_name == NULL)
! 			fkconstraint->constr_name = "<unnamed>";
  
  		for (attnum = 0; attnum < INDEX_MAX_KEYS; attnum++)
  			pktypoid[attnum] = fktypoid[attnum] = InvalidOid;
--- 1329,1343 ----
  		FkConstraint *fkconstraint = (FkConstraint *) lfirst(fkclist);
  		int			attnum;
  		List	   *fkattrs;
+ 		char	   *fkname;
  
  		/*
  		 * If the constraint has no name, set it to <unnamed>
  		 */
  		if (fkconstraint->constr_name == NULL)
! 			fkname = "<unnamed>";
! 		else
! 			fkname = fkconstraint->constr_name;
  
  		for (attnum = 0; attnum < INDEX_MAX_KEYS; attnum++)
  			pktypoid[attnum] = fktypoid[attnum] = InvalidOid;
***************
*** 1472,1675 ****
  			ReleaseSysCache(o);
  		}
  
- 		/*
- 		 * Build a CREATE CONSTRAINT TRIGGER statement for the CHECK
- 		 * action.
- 		 */
- 		fk_trigger = (CreateTrigStmt *) makeNode(CreateTrigStmt);
- 		fk_trigger->trigname = fkconstraint->constr_name;
- 		fk_trigger->relation = cxt->relation;
- 		fk_trigger->funcname = SystemFuncName("RI_FKey_check_ins");
- 		fk_trigger->before = false;
- 		fk_trigger->row = true;
- 		fk_trigger->actions[0] = 'i';
- 		fk_trigger->actions[1] = 'u';
- 		fk_trigger->actions[2] = '\0';
- 		fk_trigger->lang = NULL;
- 		fk_trigger->text = NULL;
- 
- 		fk_trigger->attr = NIL;
- 		fk_trigger->when = NULL;
- 		fk_trigger->isconstraint = true;
- 		fk_trigger->deferrable = fkconstraint->deferrable;
- 		fk_trigger->initdeferred = fkconstraint->initdeferred;
- 		fk_trigger->constrrel = fkconstraint->pktable;
- 
- 		fk_trigger->args = NIL;
- 		fk_trigger->args = lappend(fk_trigger->args,
- 								   makeString(fkconstraint->constr_name));
- 		fk_trigger->args = lappend(fk_trigger->args,
- 								   makeString((cxt->relation)->relname));
- 		fk_trigger->args = lappend(fk_trigger->args,
- 								 makeString(fkconstraint->pktable->relname));
- 		fk_trigger->args = lappend(fk_trigger->args,
- 								   makeString(fkconstraint->match_type));
- 		fk_attr = fkconstraint->fk_attrs;
- 		pk_attr = fkconstraint->pk_attrs;
- 		if (length(fk_attr) != length(pk_attr))
- 			elog(ERROR, "number of key attributes in referenced table must be equal to foreign key"
- 				 "\n\tIllegal FOREIGN KEY definition references \"%s\"",
- 				 fkconstraint->pktable->relname);
- 
- 		while (fk_attr != NIL)
- 		{
- 			id = (Ident *) lfirst(fk_attr);
- 			fk_trigger->args = lappend(fk_trigger->args,
- 									   makeString(id->name));
- 
- 			id = (Ident *) lfirst(pk_attr);
- 			fk_trigger->args = lappend(fk_trigger->args,
- 									   makeString(id->name));
- 
- 			fk_attr = lnext(fk_attr);
- 			pk_attr = lnext(pk_attr);
- 		}
- 
- 		fkactions = lappend(fkactions, (Node *) fk_trigger);
- 
  		/*
! 		 * Build a CREATE CONSTRAINT TRIGGER statement for the ON DELETE
! 		 * action fired on the PK table !!!
  		 */
- 		fk_trigger = (CreateTrigStmt *) makeNode(CreateTrigStmt);
- 		fk_trigger->trigname = fkconstraint->constr_name;
- 		fk_trigger->relation = fkconstraint->pktable;
- 		fk_trigger->before = false;
- 		fk_trigger->row = true;
- 		fk_trigger->actions[0] = 'd';
- 		fk_trigger->actions[1] = '\0';
- 		fk_trigger->lang = NULL;
- 		fk_trigger->text = NULL;
- 
- 		fk_trigger->attr = NIL;
- 		fk_trigger->when = NULL;
- 		fk_trigger->isconstraint = true;
- 		fk_trigger->deferrable = fkconstraint->deferrable;
- 		fk_trigger->initdeferred = fkconstraint->initdeferred;
- 		fk_trigger->constrrel = cxt->relation;
- 		switch ((fkconstraint->actions & FKCONSTR_ON_DELETE_MASK)
- 				>> FKCONSTR_ON_DELETE_SHIFT)
- 		{
- 			case FKCONSTR_ON_KEY_NOACTION:
- 				fk_trigger->funcname = SystemFuncName("RI_FKey_noaction_del");
- 				break;
- 			case FKCONSTR_ON_KEY_RESTRICT:
- 				fk_trigger->deferrable = false;
- 				fk_trigger->initdeferred = false;
- 				fk_trigger->funcname = SystemFuncName("RI_FKey_restrict_del");
- 				break;
- 			case FKCONSTR_ON_KEY_CASCADE:
- 				fk_trigger->funcname = SystemFuncName("RI_FKey_cascade_del");
- 				break;
- 			case FKCONSTR_ON_KEY_SETNULL:
- 				fk_trigger->funcname = SystemFuncName("RI_FKey_setnull_del");
- 				break;
- 			case FKCONSTR_ON_KEY_SETDEFAULT:
- 				fk_trigger->funcname = SystemFuncName("RI_FKey_setdefault_del");
- 				break;
- 			default:
- 				elog(ERROR, "Only one ON DELETE action can be specified for FOREIGN KEY constraint");
- 				break;
- 		}
- 
- 		fk_trigger->args = NIL;
- 		fk_trigger->args = lappend(fk_trigger->args,
- 								   makeString(fkconstraint->constr_name));
- 		fk_trigger->args = lappend(fk_trigger->args,
- 								   makeString((cxt->relation)->relname));
- 		fk_trigger->args = lappend(fk_trigger->args,
- 								 makeString(fkconstraint->pktable->relname));
- 		fk_trigger->args = lappend(fk_trigger->args,
- 								   makeString(fkconstraint->match_type));
- 		fk_attr = fkconstraint->fk_attrs;
- 		pk_attr = fkconstraint->pk_attrs;
- 		while (fk_attr != NIL)
- 		{
- 			id = (Ident *) lfirst(fk_attr);
- 			fk_trigger->args = lappend(fk_trigger->args,
- 									   makeString(id->name));
- 
- 			id = (Ident *) lfirst(pk_attr);
- 			fk_trigger->args = lappend(fk_trigger->args,
- 									   makeString(id->name));
- 
- 			fk_attr = lnext(fk_attr);
- 			pk_attr = lnext(pk_attr);
- 		}
- 
- 		fkactions = lappend(fkactions, (Node *) fk_trigger);
- 
- 		/*
- 		 * Build a CREATE CONSTRAINT TRIGGER statement for the ON UPDATE
- 		 * action fired on the PK table !!!
- 		 */
- 		fk_trigger = (CreateTrigStmt *) makeNode(CreateTrigStmt);
- 		fk_trigger->trigname = fkconstraint->constr_name;
- 		fk_trigger->relation = fkconstraint->pktable;
- 		fk_trigger->before = false;
- 		fk_trigger->row = true;
- 		fk_trigger->actions[0] = 'u';
- 		fk_trigger->actions[1] = '\0';
- 		fk_trigger->lang = NULL;
- 		fk_trigger->text = NULL;
- 
- 		fk_trigger->attr = NIL;
- 		fk_trigger->when = NULL;
- 		fk_trigger->isconstraint = true;
- 		fk_trigger->deferrable = fkconstraint->deferrable;
- 		fk_trigger->initdeferred = fkconstraint->initdeferred;
- 		fk_trigger->constrrel = cxt->relation;
- 		switch ((fkconstraint->actions & FKCONSTR_ON_UPDATE_MASK)
- 				>> FKCONSTR_ON_UPDATE_SHIFT)
- 		{
- 			case FKCONSTR_ON_KEY_NOACTION:
- 				fk_trigger->funcname = SystemFuncName("RI_FKey_noaction_upd");
- 				break;
- 			case FKCONSTR_ON_KEY_RESTRICT:
- 				fk_trigger->deferrable = false;
- 				fk_trigger->initdeferred = false;
- 				fk_trigger->funcname = SystemFuncName("RI_FKey_restrict_upd");
- 				break;
- 			case FKCONSTR_ON_KEY_CASCADE:
- 				fk_trigger->funcname = SystemFuncName("RI_FKey_cascade_upd");
- 				break;
- 			case FKCONSTR_ON_KEY_SETNULL:
- 				fk_trigger->funcname = SystemFuncName("RI_FKey_setnull_upd");
- 				break;
- 			case FKCONSTR_ON_KEY_SETDEFAULT:
- 				fk_trigger->funcname = SystemFuncName("RI_FKey_setdefault_upd");
- 				break;
- 			default:
- 				elog(ERROR, "Only one ON UPDATE action can be specified for FOREIGN KEY constraint");
- 				break;
- 		}
- 
- 		fk_trigger->args = NIL;
- 		fk_trigger->args = lappend(fk_trigger->args,
- 								   makeString(fkconstraint->constr_name));
- 		fk_trigger->args = lappend(fk_trigger->args,
- 								   makeString((cxt->relation)->relname));
- 		fk_trigger->args = lappend(fk_trigger->args,
- 								 makeString(fkconstraint->pktable->relname));
- 		fk_trigger->args = lappend(fk_trigger->args,
- 								   makeString(fkconstraint->match_type));
- 		fk_attr = fkconstraint->fk_attrs;
- 		pk_attr = fkconstraint->pk_attrs;
- 		while (fk_attr != NIL)
- 		{
- 			id = (Ident *) lfirst(fk_attr);
- 			fk_trigger->args = lappend(fk_trigger->args,
- 									   makeString(id->name));
- 
- 			id = (Ident *) lfirst(pk_attr);
- 			fk_trigger->args = lappend(fk_trigger->args,
- 									   makeString(id->name));
- 
- 			fk_attr = lnext(fk_attr);
- 			pk_attr = lnext(pk_attr);
- 		}
- 
- 		fkactions = lappend(fkactions, (Node *) fk_trigger);
  	}
  
  	/*
--- 1479,1489 ----
  			ReleaseSysCache(o);
  		}
  
  		/*
! 		 * At one point triggers were created here and added to the alist of
! 		 * actions to complete during this statement.   Trigger creation has
! 		 * been moved to constraintCreate() for dependency tracking purposes.
  		 */
  	}
  
  	/*
***************
*** 2603,2609 ****
  			transformIndexConstraints(pstate, &cxt);
  			transformFKConstraints(pstate, &cxt);
  
! 			((ColumnDef *) stmt->def)->constraints = cxt.ckconstraints;
  			*extras_before = nconc(*extras_before, cxt.blist);
  			*extras_after = nconc(cxt.alist, *extras_after);
  			break;
--- 2417,2423 ----
  			transformIndexConstraints(pstate, &cxt);
  			transformFKConstraints(pstate, &cxt);
  
! 			((ColumnDef *) stmt->def)->constraints = nconc(cxt.ckconstraints, cxt.fkconstraints);
  			*extras_before = nconc(*extras_before, cxt.blist);
  			*extras_after = nconc(cxt.alist, *extras_after);
  			break;
Index: src/backend/parser/gram.y
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/parser/gram.y,v
retrieving revision 2.323
diff -c -r2.323 gram.y
*** src/backend/parser/gram.y	2002/06/15 03:00:03	2.323
--- src/backend/parser/gram.y	2002/06/15 16:38:53
***************
*** 52,57 ****
--- 52,59 ----
  
  #include "access/htup.h"
  #include "catalog/index.h"
+ #include "catalog/pg_constraint.h"
+ #include "catalog/pg_depend.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_type.h"
  #include "nodes/makefuncs.h"
***************
*** 152,158 ****
  				simple_select
  
  %type <node>    alter_column_default
! %type <ival>    drop_behavior, opt_drop_behavior
  
  %type <list>	createdb_opt_list, createdb_opt_item
  %type <boolean>	opt_equal
--- 154,160 ----
  				simple_select
  
  %type <node>    alter_column_default
! %type <ival>    opt_drop_behavior
  
  %type <list>	createdb_opt_list, createdb_opt_item
  %type <boolean>	opt_equal
***************
*** 295,302 ****
  %type <node>	TableConstraint
  %type <list>	ColQualList
  %type <node>	ColConstraint, ColConstraintElem, ConstraintAttr
! %type <ival>	key_actions, key_delete, key_update, key_reference
! %type <str>		key_match
  %type <ival>	ConstraintAttributeSpec, ConstraintDeferrabilitySpec,
  				ConstraintTimeSpec
  
--- 297,303 ----
  %type <node>	TableConstraint
  %type <list>	ColQualList
  %type <node>	ColConstraint, ColConstraintElem, ConstraintAttr
! %type <ival>	key_actions, key_delete, key_match, key_update, key_reference
  %type <ival>	ConstraintAttributeSpec, ConstraintDeferrabilitySpec,
  				ConstraintTimeSpec
  
***************
*** 1158,1164 ****
  					$$ = (Node *)n;
  				}
  /* ALTER TABLE <relation> DROP [COLUMN] <colname> {RESTRICT|CASCADE} */
! 		| ALTER TABLE relation_expr DROP opt_column ColId drop_behavior
  				{
  					AlterTableStmt *n = makeNode(AlterTableStmt);
  					n->subtype = 'D';
--- 1159,1165 ----
  					$$ = (Node *)n;
  				}
  /* ALTER TABLE <relation> DROP [COLUMN] <colname> {RESTRICT|CASCADE} */
! 		| ALTER TABLE relation_expr DROP opt_column ColId opt_drop_behavior
  				{
  					AlterTableStmt *n = makeNode(AlterTableStmt);
  					n->subtype = 'D';
***************
*** 1177,1183 ****
  					$$ = (Node *)n;
  				}
  /* ALTER TABLE <relation> DROP CONSTRAINT <name> {RESTRICT|CASCADE} */
! 		| ALTER TABLE relation_expr DROP CONSTRAINT name drop_behavior
  				{
  					AlterTableStmt *n = makeNode(AlterTableStmt);
  					n->subtype = 'X';
--- 1178,1184 ----
  					$$ = (Node *)n;
  				}
  /* ALTER TABLE <relation> DROP CONSTRAINT <name> {RESTRICT|CASCADE} */
! 		| ALTER TABLE relation_expr DROP CONSTRAINT name opt_drop_behavior
  				{
  					AlterTableStmt *n = makeNode(AlterTableStmt);
  					n->subtype = 'X';
***************
*** 1219,1231 ****
  		| DROP DEFAULT					{ $$ = NULL; }
          ;
  
! drop_behavior: CASCADE					{ $$ = CASCADE; }
! 		| RESTRICT						{ $$ = RESTRICT; }
!         ;
! 
! opt_drop_behavior: CASCADE				{ $$ = CASCADE; }
! 		| RESTRICT						{ $$ = RESTRICT; }
! 		| /* EMPTY */					{ $$ = RESTRICT; /* default */ }
  		;
  
  
--- 1220,1228 ----
  		| DROP DEFAULT					{ $$ = NULL; }
          ;
  
! opt_drop_behavior: CASCADE				{ $$ = DEPEND_CASCADE; }
! 		| RESTRICT						{ $$ = DEPEND_RESTRICT; }
! 		| /* EMPTY */					{ $$ = DEPEND_RESTRICT; /* default */ }
  		;
  
  
***************
*** 1651,1666 ****
  
  key_match:  MATCH FULL
  			{
! 				$$ = "FULL";
  			}
  		| MATCH PARTIAL
  			{
  				elog(ERROR, "FOREIGN KEY/MATCH PARTIAL not yet implemented");
! 				$$ = "PARTIAL";
  			}
  		| /*EMPTY*/
  			{
! 				$$ = "UNSPECIFIED";
  			}
  		;
  
--- 1648,1663 ----
  
  key_match:  MATCH FULL
  			{
! 				$$ = CONSTRAINT_FKEY_FULL;
  			}
  		| MATCH PARTIAL
  			{
  				elog(ERROR, "FOREIGN KEY/MATCH PARTIAL not yet implemented");
! 				$$ = CONSTRAINT_FKEY_PARTIAL;
  			}
  		| /*EMPTY*/
  			{
! 				$$ = CONSTRAINT_FKEY_UNSPECIFIED;
  			}
  		;
  
***************
*** 1869,1878 ****
  			| /*EMPTY*/ { $$ = NULL; }
  		;
  
! DropPLangStmt:  DROP opt_procedural LANGUAGE ColId_or_Sconst
  			{
  				DropPLangStmt *n = makeNode(DropPLangStmt);
  				n->plname = $4;
  				$$ = (Node *)n;
  			}
  		;
--- 1866,1876 ----
  			| /*EMPTY*/ { $$ = NULL; }
  		;
  
! DropPLangStmt:  DROP opt_procedural LANGUAGE ColId_or_Sconst opt_drop_behavior
  			{
  				DropPLangStmt *n = makeNode(DropPLangStmt);
  				n->plname = $4;
+ 				n->behavior = $5;
  				$$ = (Node *)n;
  			}
  		;
***************
*** 2061,2071 ****
  		;
  
  
! DropTrigStmt:  DROP TRIGGER name ON qualified_name
  				{
  					DropPropertyStmt *n = makeNode(DropPropertyStmt);
  					n->relation = $5;
  					n->property = $3;
  					n->removeType = DROP_TRIGGER;
  					$$ = (Node *) n;
  				}
--- 2059,2070 ----
  		;
  
  
! DropTrigStmt:  DROP TRIGGER name ON qualified_name opt_drop_behavior
  				{
  					DropPropertyStmt *n = makeNode(DropPropertyStmt);
  					n->relation = $5;
  					n->property = $3;
+ 					n->behavior = $6;
  					n->removeType = DROP_TRIGGER;
  					$$ = (Node *) n;
  				}
***************
*** 2289,2294 ****
--- 2288,2302 ----
  				n->comment = $8;
  				$$ = (Node *) n;
  			}
+ 		| COMMENT ON CONSTRAINT name ON any_name IS comment_text
+ 			{
+ 				CommentStmt *n = makeNode(CommentStmt);
+ 				n->objtype = CONSTRAINT;
+ 				n->objname = lappend($6, makeString($4));
+ 				n->objargs = NIL;
+ 				n->comment = $8;
+ 				$$ = (Node *) n;
+ 			}
  		| COMMENT ON RULE name ON any_name IS comment_text
  			{
  				CommentStmt *n = makeNode(CommentStmt);
***************
*** 2966,2985 ****
   *
   *****************************************************************************/
  
! RemoveFuncStmt:  DROP FUNCTION func_name func_args
  				{
  					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
  					n->funcname = $3;
  					n->args = $4;
  					$$ = (Node *)n;
  				}
  		;
  
! RemoveAggrStmt:  DROP AGGREGATE func_name '(' aggr_argtype ')'
  				{
  						RemoveAggrStmt *n = makeNode(RemoveAggrStmt);
  						n->aggname = $3;
  						n->aggtype = $5;
  						$$ = (Node *)n;
  				}
  		;
--- 2974,2995 ----
   *
   *****************************************************************************/
  
! RemoveFuncStmt:  DROP FUNCTION func_name func_args opt_drop_behavior
  				{
  					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
  					n->funcname = $3;
  					n->args = $4;
+ 					n->behavior = $5;
  					$$ = (Node *)n;
  				}
  		;
  
! RemoveAggrStmt:  DROP AGGREGATE func_name '(' aggr_argtype ')' opt_drop_behavior
  				{
  						RemoveAggrStmt *n = makeNode(RemoveAggrStmt);
  						n->aggname = $3;
  						n->aggtype = $5;
+ 						n->behavior = $7;
  						$$ = (Node *)n;
  				}
  		;
***************
*** 2988,2998 ****
  		| '*'									{ $$ = NULL; }
  		;
  
! RemoveOperStmt:  DROP OPERATOR any_operator '(' oper_argtypes ')'
  				{
  					RemoveOperStmt *n = makeNode(RemoveOperStmt);
  					n->opname = $3;
  					n->args = $5;
  					$$ = (Node *)n;
  				}
  		;
--- 2998,3009 ----
  		| '*'									{ $$ = NULL; }
  		;
  
! RemoveOperStmt:  DROP OPERATOR any_operator '(' oper_argtypes ')' opt_drop_behavior
  				{
  					RemoveOperStmt *n = makeNode(RemoveOperStmt);
  					n->opname = $3;
  					n->args = $5;
+ 					n->behavior = $7;
  					$$ = (Node *)n;
  				}
  		;
***************
*** 3160,3170 ****
  		;
  
  
! DropRuleStmt:  DROP RULE name ON qualified_name
  				{
  					DropPropertyStmt *n = makeNode(DropPropertyStmt);
  					n->relation = $5;
  					n->property = $3;
  					n->removeType = DROP_RULE;
  					$$ = (Node *) n;
  				}
--- 3171,3182 ----
  		;
  
  
! DropRuleStmt:  DROP RULE name ON qualified_name opt_drop_behavior
  				{
  					DropPropertyStmt *n = makeNode(DropPropertyStmt);
  					n->relation = $5;
  					n->property = $3;
+ 					n->behavior = $6;
  					n->removeType = DROP_RULE;
  					$$ = (Node *) n;
  				}
Index: src/backend/parser/parse_func.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/parser/parse_func.c,v
retrieving revision 1.131
diff -c -r1.131 parse_func.c
*** src/backend/parser/parse_func.c	2002/05/20 23:51:42	1.131
--- src/backend/parser/parse_func.c	2002/06/15 16:38:53
***************
*** 1248,1254 ****
  
  	if (caller == NULL)
  	{
! 		elog(ERROR, "Function %s(%s) does not exist%s%s",
  			 NameListToString(funcname), argbuf.data,
  			 ((msg != NULL) ? "\n\t" : ""), ((msg != NULL) ? msg : ""));
  	}
--- 1248,1254 ----
  
  	if (caller == NULL)
  	{
! 		elog(ERROR, "Function '%s(%s)' does not exist%s%s",
  			 NameListToString(funcname), argbuf.data,
  			 ((msg != NULL) ? "\n\t" : ""), ((msg != NULL) ? msg : ""));
  	}
Index: src/backend/rewrite/rewriteDefine.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/rewrite/rewriteDefine.c,v
retrieving revision 1.72
diff -c -r1.72 rewriteDefine.c
*** src/backend/rewrite/rewriteDefine.c	2002/05/21 22:05:55	1.72
--- src/backend/rewrite/rewriteDefine.c	2002/06/15 16:38:53
***************
*** 17,22 ****
--- 17,24 ----
  #include "access/heapam.h"
  #include "catalog/catname.h"
  #include "catalog/indexing.h"
+ #include "catalog/pg_depend.h"
+ #include "catalog/pg_namespace.h"
  #include "catalog/pg_rewrite.h"
  #include "commands/view.h"
  #include "miscadmin.h"
***************
*** 49,62 ****
  		   char *evqual,
  		   char *actiontree)
  {
! 	int			i;
! 	Datum		values[Natts_pg_rewrite];
! 	char		nulls[Natts_pg_rewrite];
! 	NameData	rname;
! 	Relation	pg_rewrite_desc;
! 	TupleDesc	tupDesc;
! 	HeapTuple	tup;
! 	Oid			rewriteObjectId;
  
  	if (IsDefinedRewriteRule(eventrel_oid, rulname))
  		elog(ERROR, "Attempt to insert rule \"%s\" failed: already exists",
--- 51,66 ----
  		   char *evqual,
  		   char *actiontree)
  {
! 	int				i;
! 	Datum			values[Natts_pg_rewrite];
! 	char			nulls[Natts_pg_rewrite];
! 	NameData		rname;
! 	Relation		pg_rewrite_desc;
! 	TupleDesc		tupDesc;
! 	HeapTuple		tup;
! 	Oid				rewriteObjectId;
! 	ObjectAddress	myself,
! 					dependee;
  
  	if (IsDefinedRewriteRule(eventrel_oid, rulname))
  		elog(ERROR, "Attempt to insert rule \"%s\" failed: already exists",
***************
*** 100,105 ****
--- 104,125 ----
  						   tup);
  		CatalogCloseIndices(Num_pg_rewrite_indices, idescs);
  	}
+ 
+ 	/*
+ 	 * Create Dependencies
+ 	 *	- Class of relation
+ 	 */
+ 	myself.classId = GetSysCacheOid(RELNAMENSP,
+ 									CStringGetDatum(RewriteRelationName),
+ 									ObjectIdGetDatum(PG_CATALOG_NAMESPACE),
+ 									0, 0);
+ 	myself.objectId = tup->t_data->t_oid;
+ 	myself.objectSubId = 0;
+ 	
+ 	dependee.classId = RelOid_pg_class;
+ 	dependee.objectId = eventrel_oid;
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, true);
  
  	heap_freetuple(tup);
  
